function gadget:GetInfo()
  return {
    name      = "spawn enemies!!",
    desc      = "spawns things, highscore",
    author    = "knorke",
    date      = "2015",
    license   = "push button magic",
    layer     = 5,
    enabled   = true  --  loaded on a horse?
  }
end
--?
 -- [f=0028074] Error: LuaRules::RunCallIn: error = 2, UnitDestroyed, [string "LuaRules/Gadgets/game_energy_conversion.lua"]:189: attempt to index field '?' (a nil value)
if gadgetHandler:IsSyncedCode() then




local GaiaTeamID = Spring.GetGaiaTeamID()
local score = 0
_G.score = 0
local nextAnnounce = 1000
local timeLeft = 6000*10
_G.timeLeft = 6000*10
_G.gameOver = false
local gameOver = false
waveDelay = 10 * 30
function gadget:GameStart()

end

function gadget:Initialize()
   local gaiaTeamID = Spring.GetGaiaTeamID()
	local teams = Spring.GetTeamList()
	for i = 1,#teams do
		local teamID = teams[i]                
		if (teamID ~= gaiaTeamID) then 			 	
			x=Game.mapSizeX-(i*200)
			z=(Game.mapSizeZ/2)
			local unitID = Spring.CreateUnit("arm_mobile_fusion", x, 0, z, 0, teamID)
		end
	end
end



units = {"arm_peewee", "arm_peewee","arm_peewee","arm_peewee", "arm_rocko"}

function gadget:UnitDestroyed(unitID, unitDefID, teamID, attackerID, attackerDefID, attackerTeamID)	
	if gameOver then return end
	if (teamID == GaiaTeamID) then	
		score = score + 1--  (UnitDefs[unitDefID].metalCost or 1)
		if score == 50 then units = {"arm_zipper"} end
		if score == 75 then units = {"arm_peewee", "arm_peewee", "arm_peewee", "arm_rocko", "arm_rocko", "arm_rocko", "core_ak", "core_pyro"} end
		if score == 150 then units = {"arm_peewee", "arm_rocko", "arm_rocko", "arm_rocko", "core_ak", "core_pyro", "core_dominator", "core_roach", "arm_zipper"}  end

		timeLeft=timeLeft + 2
		_G.score = score
		if score > nextAnnounce then
			Spring.Echo ("score: " .. score)
			nextAnnounce = nextAnnounce+50
		end
	end
end

function gadget:GameFrame (f)
	--Spring.Echo (f)
	if f%30==0 and not gameOver then
		timeLeft=timeLeft-1
		if timeLeft < 0 then
			gameOver = true
			_G.gameOver = true
			Spring.Echo ("YOUR FINAL SCORE IS " .. score)
		end
		_G.timeLeft = timeLeft		
	end	
	if gameOver and f%90==0 then
		Spring.Echo ("YOUR FINAL SCORE IS " .. score)
	end
	
	if f%waveDelay==0 then
	SpawnWave()
	end
end


function SpawnWave ()
	x=math.random (50,200)
	z=math.random (100, Game.mapSizeZ-200)
	 for i=1,5 do
		local name = units[math.random(1,#units)]	
		local unitID = Spring.CreateUnit(name, x+i*60, 0, z, 0, GaiaTeamID)
		x1=Game.mapSizeX/2
		z1=math.random (100, Game.mapSizeZ-200)
		Spring.GiveOrderToUnit(unitID, CMD.FIGHT , {x1, Spring.GetGroundHeight(x1, z1), z1}, {"shift"})
		
		x2=Game.mapSizeX-10
		z2=(Game.mapSizeZ/2) -- + math.random (-500,500)
		Spring.GiveOrderToUnit(unitID, CMD.FIGHT , {x2, Spring.GetGroundHeight(x2, z2), z2}, {"shift"})
		
		x3=math.random (10, Game.mapSizeX-10)
		z3=math.random (10, Game.mapSizeZ-10)
		Spring.GiveOrderToUnit(unitID, CMD.PATROL , {x3, Spring.GetGroundHeight(x3, z3), z3}, {"shift"})
		
	end 
end

else----unsynced----

function gadget:DrawWorld () 
  --Spring.Echo ("draw")
    --gl.Billboard()
  --gl.MultiTexCoord(1, 1)  
  gl.PushMatrix()
  gl.Translate(2700, 200, 5)
  gl.Color(1, 1, 1,1)
  local text = "score:" .. SYNCED.score
  gl.Text(text, 0, 0, 200)
  gl.PopMatrix()
  gl.PushMatrix()
  gl.Translate(2700, 200, 5)
  gl.Color(1, 1, 1,1)  
  if SYNCED.gameOver then text = "TIME IS UP! gg!" else
	text = "time:" .. SecondsToClock (SYNCED.timeLeft)
	end

  gl.PopMatrix()
end


function SecondsToClock(sSeconds)
nSeconds = (sSeconds or 0) +0
nHours = string.format("%02.f", math.floor(nSeconds/3600));
nMins = string.format("%02.f", math.floor(nSeconds/60 - (nHours*60)));
nSecs = string.format("%02.f", math.floor(nSeconds - nHours*3600 - nMins *60));
return nMins..":"..nSecs
end

end